// Copyright 1998 by Jon Dart.  All Rights Reserved.
#ifndef _CONFIG_H
#define _CONFIG_H

#include "chess.h"

// search parameters and options
#define INITIAL_SEARCH_WINDOW PAWN_VALUE

// One "ply" of search extension:
static const int DEPTH_INCREMENT = 12;
#define QSEARCH_FORWARD_PRUNE_BIAS (5*PAWN_VALUE)/4
// variable null depth reduction (between R=2 and R=3):
#define ADAPTIVE_NULL
#define VERIFY_NULL_SEARCH
#define FUTILITY_DEPTH DEPTH_INCREMENT
#define FUTILITY_PRUNE
#define FUTILITY_MARGIN (3*PAWN_VALUE)
#define EXTENDED_FUTILITY_PRUNE
#define EXTENDED_FUTILITY_DEPTH 2*DEPTH_INCREMENT
#define EXTENDED_FUTILITY_MARGIN (6*PAWN_VALUE)
#define RAZORING
#define RAZOR_DEPTH 3*DEPTH_INCREMENT
#define RAZOR_MARGIN (QUEEN_VALUE)
#define RAZOR_EXTENSION -DEPTH_INCREMENT
#define CHECK_EXTENSION DEPTH_INCREMENT
#define FORCED_EXTENSION DEPTH_INCREMENT
#define RECAPTURE_EXTENSION (3*DEPTH_INCREMENT)/4
#define REPETITION_EXTENSION (DEPTH_INCREMENT)/2
#define PAWN_PUSH_EXTENSION DEPTH_INCREMENT
#define THREAT_EXTENSION (3*DEPTH_INCREMENT)/4
#define HISTORY_REDUCTION (DEPTH_INCREMENT)

// iteration to start thread splitting
#define THREAD_SPLIT_START 6
// max depth at which to do splitting
#define THREAD_SPLIT_LIMIT 3

// Scoring options
#define USE_LAZY_EVAL

// statistics
#define EVAL_STATS
//#define MOVE_ORDER_STATS
#define SMP_STATS

#endif
