// Copyright 1995 by Jon Dart. All Rights Reserved.

#include "srcdata.h"
#include "globals.h"

void SearchData::init() {
   ply0moves = new Move[Constants::MaxMoves];
   ply0scores = new int[Constants::MaxMoves];
   for (int i = 0; i < Constants::MaxPly; i++)
      moves_generated[i] = new Move[Constants::MaxMoves];
}

SearchData::~SearchData() {
   delete [] ply0moves;
   delete [] ply0scores;
   for (int i = 0; i< Constants::MaxPly;i++)
   {
      if (moves_generated[i] != NULL)
         delete [] moves_generated[i];
   }
}

void SearchData::set_killer(const Move &move) {
#ifdef _TRACE
   indent(mgs.ply); cout << "set_killer, ply " << mgs.ply << ": " << MoveImage(move) << endl;
#endif
    if (!MovesEqual(move,Killers1[mgs.ply])) {
       if (options.search.num_killers > 1)
       {
          Killers2[mgs.ply] = Killers1[mgs.ply];
       }
       if (options.search.num_killers > 0)
       {
          Killers1[mgs.ply] = move;
       }
   }
}

void SearchData::clear_killer()
{
   for (int i = 0; i < Constants::MaxPly; i++)
   {
      Killers1[i] =
      Killers2[i] = NullMove;   
   }
}

void 
SearchData::clear_history()
{
   memset(HistoryW,'\0',4096*sizeof(int));
   memset(HistoryB,'\0',4096*sizeof(int));
}

void 
SearchData::update_history(const Move & move, unsigned depth)
{
   if (1) //options.search.use_history)
   {
      if (Capture(move) != EmptyPiece || PromoteTo(move) != InvalidPiece) return;
      if (board.Side() == White)
         HistoryW[(int)StartSquare(move)][(int)DestSquare(move)] += depth;
      else
         HistoryB[(int)StartSquare(move)][(int)DestSquare(move)] += depth;
   }
}

