// Copyright 2005 by Jon Dart. All Rights Reserved.

#ifndef _SEARCHDATA_H
#define _SEARCHDATA_H

#include "move.h"
#include "board.h"
#include "constant.h"

struct MoveGenStatus {
   int ply;
   int moves_generated;
   int phase, losers_count,index,batch_count,evasion_count;
   Move hashMove;
   int non_captures_count,history_count,num_losers;
   Move *batch;
   Move losers[100];
   Move moves[Constants::MaxMoves];
};

struct SearchData {
    SearchData(const Board &b) 
       :board(b) {
       init();
    }
    SearchData() {
       init();
    }
    virtual ~SearchData();
    void init();
    Board board;
    Move *ply0moves;
    int ply0move_count;
    int *ply0scores;
    Move *moves_generated[Constants::MaxPly];
    Move best[Constants::MaxPly];
    Move last_move[Constants::MaxPly];
    int extensions[Constants::MaxPly];
    int move_index;
    Move Killers1[Constants::MaxPly];
    Move Killers2[Constants::MaxPly];
    long HistoryW[64][64];
    long HistoryB[64][64];
    // move generator variables
    MoveGenStatus mgs;

    void set_killer(const Move &);
    void clear_killer();
    void clear_history();
    void update_history(const Move &, unsigned depth);
};

#endif

